
Set objArgs = WScript.Arguments
Set oShell  = WScript.CreateObject ("WScript.shell")
Set fso     = CreateObject("Scripting.FileSystemObject")

Dim Windir
Dim FullQualifiedEngineName
' if Win64, restart with WScript.exe/CScript.exe 32 bits
On Error Resume Next
Windir = oShell.ExpandEnvironmentStrings("%WinDir%")
FullQualifiedEngineName = Windir+"\SysWOW64" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))
If fso.FolderExists(Windir+"\SysWOW64") And _
   LCase(WScript.FullName) <>  LCase(FullQualifiedEngineName) And _
   LCase(WScript.FullName) = LCase(Windir+"\System32" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))) And _
   fso.FileExists(FullQualifiedEngineName) = True Then
    If objArgs.Count > 0 Then
      cmdOptions =""
      For i=0 To objArgs.Count -1
        cmdOptions = cmdOptions + Chr(34) + objArgs(i) + Chr(34) + " "
      Next
    End If
    oShell.Run FullQualifiedEngineName + " " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34) + " " + cmdOptions
    WScript.Quit
End If

Dim crible  '...French touch :-)
Dim prime_number : prime_number = 2
Dim offset_prime : offset_prime = 1

Set ScriptEZ = WScript.CreateObject("ScriptEZ.API","ScriptEZ_")

highValue = ScriptEZ.InputComboBox(0,"Search for prime numbers beyond a number, please enter a number:|&Ok|&Cancel",1)
If Len(highValue) <= 0 Then WScript.Quit

'-- Array of integers factory
Set dico = CreateObject("Scripting.Dictionary")
For i=prime_number To highValue+1
  dico.Add CStr(i), CStr(i)
Next
crible = dico.Items '-- extract the array
Set dico = Nothing

'-- Create a thread pool of 1 thread
hThreadPool = ScriptEZ.CreateTaskQueueObject(1)
'-- Submit a recurring task which implements the prime numbers search with Eratosthenes method
r = ScriptEZ.AddTask(hThreadPool,UBound(crible)-1)

'-- Block and yield the control to the thread pool
Do Until 0
  WScript.Sleep 1000
Loop

'-- Callback to process iteratively the search for prime numbers
Function ScriptEZ_OnRun(localStorage)
  WScript.Sleep 50
  Dim new_prime_number : new_prime_number  = 0
  Dim multiple_found : multiple_found = false
  
  '-- Browse across the sieve and delete not prime numbers 
  For i=offset_prime To localStorage
     If crible(i) <> prime_number And crible(i) <> 0 And (crible(i) Mod prime_number) = 0 Then  
       ScriptEZ.Echo " -> " + CStr(crible(i)) + " isn't a prime number: " + _
                     CStr(prime_number) + "x" + CStr(crible(i)/prime_number)
       crible(i) = 0
       multiple_found = true
     ElseIf crible(i) <> prime_number And crible(i) <> 0 And new_prime_number = 0 Then 
       new_prime_number = crible(i)
       offset_prime = i
     End If
  Next
  
  prime_number = new_prime_number '-- keep a new prime number
  
  If multiple_found = false Then
      ScriptEZ.Echo vbLf + "Prime numbers list beyond " + CStr(localStorage + 2) +  " is: " + vbCrlf
      For i=0 To localStorage
       If crible(i) > 0 Then ScriptEZ.Echo " ." + CStr(crible(i)) 
      Next 
      '-- Show API coverage
      ScriptEZ.Echo vbLf + "View of API Coverage is:" + _ 
                    ScriptEZ.ConvertStringToBSTR(ScriptEZ.ProbeMemoryStatus(32))
      ScriptEZ_OnRun = CLng(0) '-- done, the search is achieved
  Else
      ScriptEZ_OnRun = CLng(1) '-- go ahead again
  End If
End Function