'//////////////////////////////////////////////////////////////////////////////
' Author: SYOU
' Version 1.0
' Company: Etude Conception Informatique
' Purpose: get and set filetimestamp from ScriptEZ.dll to this script file
'//////////////////////////////////////////////////////////////////////////////
main()

Sub main()

  Set WshShell = CreateObject("WScript.Shell")
  Set fso      = CreateObject("Scripting.FileSystemObject")

  Dim Windir
  Dim FullQualifiedEngineName
  '-- if Win64, restart with WScript.exe/CScript.exe 32 bits
  On Error Resume Next
  Windir = WshShell.ExpandEnvironmentStrings("%WinDir%")
  FullQualifiedEngineName = Windir+"\SysWOW64" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))
  If fso.FolderExists(Windir+"\SysWOW64") And _
     LCase(WScript.FullName) <>  LCase(FullQualifiedEngineName) And _
     LCase(WScript.FullName) = LCase(Windir+"\System32" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))) And _
     fso.FileExists(FullQualifiedEngineName) = True Then
    WshShell.Run FullQualifiedEngineName + " " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34)
    Exit Sub
  End If

  Dim scriptEZ
  Set scriptEZ = CreateObject("ScriptEZ.API")
  
  ScriptEZ.AppRegister
  ' get path of ScriptEZ.dll
  dllPath = ScriptEZ.GetOpenDlgDirectoryPath("uri://scriptez.dll?path")
  ' get filetimestamp of ScriptEZ.dll
  fileTimeStamp = ScriptEZ.GetFileTimeStamp( dllPath+ "ScriptEZ.dll")
  ' convert filetimestamp binary structure to Basic String (BSTR)
  fileTimeStampBSTR = ScriptEZ.BinaryToBSTR(fileTimeStamp,24)
  ' free allocated memory for filetimestamp
  r = ScriptEZ.RestoreFileTimeStamp(vbNullString,fileTimeStamp)
  
  MsgBox fileTimeStampBSTR,,"ScriptEZ.dll - file timestamp as text"
  ' convert reversely filetimestamp as Basic String to binary structure
  fileTimeStamp = ScriptEZ.BSTRToBinary(fileTimeStampBSTR)
  ' set the filetimestamp to this script file
  r = ScriptEZ.RestoreFileTimeStamp(WScript.ScriptFullName,fileTimeStamp)
  ' free allocated memory for filetimestamp
  r = ScriptEZ.RestoreFileTimeStamp(vbNullString,fileTimeStamp)
  
  MsgBox "Pause"
  Set scriptEZ = Nothing
  
End Sub