'//////////////////////////////////////////////////////////////////////////////
' Author: SY
' Demo ScriptEZ.API based application which uses facilities from RAD API:
' . SendMail() based on SMTP (Simple Message Transfert Protocol)
' . Echo() method usage which displays always messages into a console window
'   instead of WScript.Echo() with 2 behaviours for cscript.exe or wscript.exe
' . ScriptEZ.API Remoting Control Interface usage by NPTelnet.exe program
'   (Connect to ScriptEZ.API process with <processid (PID)> as connection name)
'
' Purpose: Testing SendMail property
'//////////////////////////////////////////////////////////////////////////////
const SCRIPTEZ_API = "ScriptEZ.API" ' Component name
Dim ScriptEZMain

' start the script
'/////////////////
'On Error Resume Next
Main()

' Main Subroutine
'////////////////
Sub Main()

  Set WshShell = CreateObject("WScript.Shell")
  Set fso      = CreateObject("Scripting.FileSystemObject")
  
  Dim Windir
  Dim FullQualifiedEngineName
  ' if Win64, restart with WScript.exe/CScript.exe 32 bits
  On Error Resume Next
  Windir = WshShell.ExpandEnvironmentStrings("%WinDir%")
  FullQualifiedEngineName = Windir+"\SysWOW64" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))
  If fso.FolderExists(Windir+"\SysWOW64") And _ 
     LCase(WScript.FullName) <>  LCase(FullQualifiedEngineName) And _
     LCase(WScript.FullName) = LCase(Windir+"\System32" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))) And _
     fso.FileExists(FullQualifiedEngineName) = True Then
    WshShell.Run FullQualifiedEngineName + " " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34)
    Exit Sub
  End If

  ' instantiate component object with callback interface
  Set ScriptEZMain = WScript.CreateObject(SCRIPTEZ_API)
  If Not IsObject(ScriptEZMain) Then Exit Sub

  ScriptEZMain.AppRegister

  ' Using SSL
  'r = ScriptEZMain.SendMail("smtp.gmail.com",
  '                          "expediteur@gmail.com|expediteur|sesame",
  '                          "destinataire@gmail.com",
  '                          "Test sendmail","Corps du message"+vbLF+"Bye!","")
  'ScriptEZMain.Echo "SendMail call status over smtp.gmail.com: " + CStr(r)

  ' No SSL
  r = ScriptEZMain.SendMail("smtp.free.fr", _
                            "expediteur@gmail.com", _ 
                            "destinataire@gmail.com,destinatire2@mail.com", _
                            "Test sendmail","Corps du message"+vbLF+"Bye!", _
                            "")
  ' r = 0 if OK
  ScriptEZMain.Echo "SendMail call status over smtp.free.fr: " + CStr(r)
  
  ' App unregister before ending
  ScriptEZMain.AppUnregister
  WScript.Sleep 4000
  Set ScriptEZMain = Nothing

End Sub

