'/////////////////////////////////////////////////////////////////////////////////
' Author: SYO
' Copyright (c) 2015
'
' Purpose: Watch any change notification event from items (files and subfolders) 
' into a directory so a trigger program can be started with this event.
' 
'/////////////////////////////////////////////////////////////////////////////////
Const targetDirectory = "C:\APIDev"
Dim changeCounter
Dim ScriptEZ

Main()

Sub Main()

    Set WshShell = CreateObject("WScript.Shell")
    Set fso      = CreateObject("Scripting.FileSystemObject")
      
    Dim Windir
    Dim FullQualifiedEngineName
    ' if Win64, restart with WScript.exe/CScript.exe 32 bits
    On Error Resume Next
    Windir = WshShell.ExpandEnvironmentStrings("%WinDir%")
    FullQualifiedEngineName = Windir+"\SysWOW64" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))
    If fso.FolderExists(Windir+"\SysWOW64") And _ 
     LCase(WScript.FullName) <>  LCase(FullQualifiedEngineName) And _
     LCase(WScript.FullName) = LCase(Windir+"\System32" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))) And _
     fso.FileExists(FullQualifiedEngineName) = True Then
     WshShell.Run FullQualifiedEngineName + " " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34)
     Exit Sub
    End If

    Set ScriptEZ = WScript.CreateObject("ScriptEZ.API","ScriptEZ_")
    ScriptEZ.AppRegister
    ScriptEZ.Echo CStr(Time) + " - Directory : "  + targetDirectory + " in watch"
    changeCounter = 0
    notificationHandle = ScriptEZ.WaitForDirectoryChangeNotification(targetDirectory,0,0)
    If notificationHandle > 0 Then
        hThreadPool = ScriptEZ.CreateTaskQueueObject(1)
        r = ScriptEZ.AddTask(hThreadPool,notificationHandle)
    End If

    Do while (true)
        Wscript.Sleep 1000
    Loop
End Sub

Function ScriptEZ_onRun(localStorage)
    '-- waiting and yielding control to client code
    r = ScriptEZ.WaitForDirectoryChangeNotification("",localStorage,7)
    If r > 0 And changeCounter = 0 Then 
      ScriptEZ.Echo CStr(Time) + " - onChange : " + CStr(changeCounter)
      changeCounter = 1
    ElseIf r = 0 And  changeCounter > 0 Then 
         ScriptEZ.Echo CStr(Time) +  " - Changes occurred into " + targetDirectory + " => triggering a program" 
         '--running a program here...
         changeCounter = 0
    End If
    ScriptEZ_onRun = CLng(1) '-- run again and again
    
End Function
